//
//  MyTouchTracker.m
//  Week6_QuartzAnimationTouches
//
//  Created by Jason Fieldman on 2/17/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "MyTouchTracker.h"


@implementation MyTouchTracker


- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {

		/* We can affect our properties from inside the init */
		self.backgroundColor = [UIColor clearColor];
		
		/* Handle multitouch */
		self.multipleTouchEnabled = YES;
		
		/* Create a CoreAnimation layer */
		myLayer1 = [CALayer layer];
		myLayer1.backgroundColor = [UIColor redColor].CGColor;
		myLayer1.frame = CGRectMake(40, 100, 40, 40);
		[self.layer addSublayer:myLayer1];
				
    }
    return self;
}

/* If we're not drawing custom stuff, make sure this is removed! */
//- (void)drawRect:(CGRect)rect {
//}


- (void)dealloc {
    [super dealloc];
}


/* Handle the event when a user hits the mouse on the view */
- (void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
	/* Get the array of touches inside of this view */
	NSArray *myTouches = [[event touchesForView:self] allObjects];
	
	/* Get the first touch */
	UITouch *t = [myTouches objectAtIndex:0];
	
	/* Where is it? */
	CGPoint p =  [t locationInView:self];

	/* Let's animate our sublayer to this point! */
	CABasicAnimation *animation;
	
	animation = [CABasicAnimation animationWithKeyPath:@"position"];	
	animation.delegate  = self;
	animation.duration  = 0.25;
	animation.fromValue = [NSValue valueWithCGPoint:(myLayer1.position)];
	animation.toValue   = [NSValue valueWithCGPoint:(p)];
	[myLayer1 addAnimation:animation forKey:@"animatePosition"];
	
	/* We need this to set the position after the animation is finished */
	myLayer1.position = p;
	
	/* Multiple touches? */
	if ([myTouches count] > 1) {
		myLayer1.frame = CGRectInset(myLayer1.frame, -5, -5);
	}
}


/* Handle the event when a user hits the mouse on the view */
- (void) touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
	/* Get the array of touches inside of this view */
	NSArray *myTouches = [[event touchesForView:self] allObjects];
	
	/* Get the first touch */
	UITouch *t = [myTouches objectAtIndex:0];
	
	/* Where is it? */
	CGPoint p =  [t locationInView:self];
	
	/* We need this to set the position after the animation is finished */
	myLayer1.position = p;
	
}




/* Handle the end of the animation */
- (void)animationDidStop:(CAAnimation *)theAnimation finished:(BOOL)flag {
	int newColor = rand() % 3;

	/* Notice the implicit animation between colors when this is set */
	myLayer1.backgroundColor = (newColor == 0) ? [UIColor redColor].CGColor : ((newColor == 1) ? [UIColor blueColor].CGColor : [UIColor greenColor].CGColor);
}


@end
